
// global init of HTTPrequest object
var request;
request = window.XMLHttpRequest ?
new XMLHttpRequest() : new ActiveXObject("MSXML2.XMLHTTP.3.0");

function get_url(url)
{
    request.open("GET", url, false); // synchronous request
    request.send('');
    return request.responseText;
}

// global init of refresh timer
var refresh_seconds = 1;
var refresh_delay = 1;
var timer = setTimeout("refresh_timer();", refresh_seconds*1000); // milliseconds
var refresh_active = false;
var ply_nr = 0;
var movelist = '';
var wtim = 3600;
var btim = 3600;
var wchanc = '<img src="gifs/swc.gif">';
var bchanc = '<img src="gifs/sbc.gif">';
var warchb = '<img src="gifs/swa.gif">';
var barchb = '<img src="gifs/sba.gif">';
var wdisplatime = '60:00';
var bdisplatime = '60:00';
var wscore = '0/0';
var bscore = '0/0';

function def_chanc()
{
    wchanc = '<img src="gifs/swc.gif">';
    bchanc = '<img src="gifs/sbc.gif">';
    document.getElementById('whitechancellor').src = "gifs/swc.gif";
    document.getElementById('blackchancellor').src = "gifs/sbc.gif";
}

function def_arch()
{
    warchb = '<img src="gifs/swa.gif">';
    barchb = '<img src="gifs/sba.gif">';
    document.getElementById('whitearchbishop').src = "gifs/swa.gif";
    document.getElementById('blackarchbishop').src = "gifs/sba.gif";
}

function vor_chanc()
{
    wchanc = '<img src="gifs/wcv.gif">';
    bchanc = '<img src="gifs/bcv.gif">';
    document.getElementById('whitechancellor').src = "gifs/wcv.gif";
    document.getElementById('blackchancellor').src = "gifs/bcv.gif";
}

function smirf_arch()
{
    warchb = '<img src="gifs/was.gif">';
    barchb = '<img src="gifs/bas.gif">';
    document.getElementById('whitearchbishop').src = "gifs/was.gif";
    document.getElementById('blackarchbishop').src = "gifs/bas.gif";
}

function refresh_timer()
{
    play_moves();
    timer = setTimeout("refresh_timer();", refresh_seconds*1000); // milliseconds
}


function disp_alert()
{
    alert("Yet to be implemented!");
}

function play_moves()
{
    if (refresh_active) // no reentry
       return;

   refresh_active = true;

   // decrement clocks
   if(ply_nr & 1) {
       btim--;
       tmpt = btim % 60; if(tmpt < 10) tmpt = '0'+tmpt;
       bdisplatime = Math.floor(btim/60) + ':' + tmpt;

   } else {
       wtim--;
       tmpt = wtim % 60; if(tmpt < 10) tmpt = '0'+tmpt;
       wdisplatime = Math.floor(wtim/60) + ':' + tmpt;
   }

   // check if it is time to update move list
   refresh_delay--; if(refresh_delay > 0) { refresh_active = 0; return; }

   // check if we already have downloaded moves that are not played yet
   gamemoves = movelist.split(';');


   if( gamemoves.length-2 <= ply_nr || gamemoves[0] == '' ) {
       // All moves we have are played. Fetch new move list
       date = new Date();
       time = date.getTime(); // milliseconds since 1970
       movelist = get_url('moves.txt?dummy='+time);

       if( gamemoves.length-2 < ply_nr ) {
           ply_nr = 0; historylist = '';
       }
       gamemoves = movelist.split(';');
   }

   document.title = wdisplatime + '  ' + gamemoves[0] + '  vs  ' +
                                         gamemoves[1] + '  ' + bdisplatime +
                     ' (' + wscore + ' ' + bscore + ')';

   refresh_delay = 10;

   if( gamemoves.length-2 < ply_nr) {
           refresh_delay = -1;
           refresh_active = 0;
           return;
   }
   if( gamemoves.length-2 > ply_nr) {
       // We have moves to play, from old or new list.
       nextmove = gamemoves[ply_nr+2]; ++ply_nr; // Get next move
       if(nextmove.length == 1) { // game-end message
           if(nextmove == '+') {
               document.getElementById('bking').src = "gifs/sbkl.gif";
           }
           if(nextmove == '-') {
               document.getElementById('wking').src = "gifs/swkl.gif";
           }
           if(nextmove == '=') {
               document.getElementById('wking').src = "gifs/sgk.gif";
               document.getElementById('bking').src = "gifs/sgk.gif";
           }
           refresh_delay = -1;
           refresh_active = 0;
           return;
       }
       nextsquares = nextmove.split('/');
       squares = nextsquares[0].split(':');         // Split in from and to square
       for(i = 0; i < squares.length; i = i + 2) // allow for multiple from, to
       {  if(squares[i].length == 1) {
              if(ply_nr & 1) {
                  if(squares[i] == 'q') tmp = '<img src="gifs/swq.gif">';
                  if(squares[i] == 'n') tmp = '<img src="gifs/swn.gif">';
                  if(squares[i] == 'r') tmp = '<img src="gifs/swr.gif">';
                  if(squares[i] == 'b') tmp = '<img src="gifs/swb.gif">';
                  if(squares[i] == 'c') tmp = wchanc;
                  if(squares[i] == 'a') tmp = warchb;
              } else {
                  if(squares[i] == 'q') tmp = '<img src="gifs/sbq.gif">';
                  if(squares[i] == 'n') tmp = '<img src="gifs/sbn.gif">';
                  if(squares[i] == 'r') tmp = '<img src="gifs/sbr.gif">';
                  if(squares[i] == 'b') tmp = '<img src="gifs/sbb.gif">';
                  if(squares[i] == 'c') tmp = bchanc;
                  if(squares[i] == 'a') tmp = barchb;
              }
              document.getElementById(squares[i+1]).innerHTML = tmp;
          } else {
              document.getElementById(squares[i+1]).innerHTML =
              document.getElementById(squares[i]).innerHTML;
              document.getElementById(squares[i]).innerHTML =
              '<img src="gifs/snl.gif">';
          }
       }
       if(nextsquares.length > 1) {
           if(ply_nr & 1)
              wscore = nextsquares[1] + '/' + (nextsquares[2]/100);
           else
              bscore = nextsquares[1] + '/' + (nextsquares[2]/100);
       }
       if(nextsquares.length == 4) {
           if(ply_nr & 1) {
               wtim = nextsquares[3];
               tmpt = wtim % 60; if(tmpt < 10) tmpt = '0'+tmpt;
               wdisplatime = Math.floor(wtim/60) + ':' + tmpt;
           } else {
               btim = nextsquares[3];
               tmpt = btim % 60; if(tmpt < 10) tmpt = '0'+tmpt;
               bdisplatime = Math.floor(btim/60) + ':' + tmpt;
           }
       }
       refresh_delay = 1; // Play fast as long as there are moves
   }

   document.title = wdisplatime + '  ' + gamemoves[0] + '  vs  ' +
                                         gamemoves[1] + '  ' + bdisplatime
                     + ' (' + wscore + ' ' + bscore + ')';

   refresh_active = false;
}
