function do_move()
{
   move = document.getElementById('move').value;
   document.getElementById('move').value = '';
   debugx = document.getElementById('debug'); 

   positions = move.split(' ', 2);

   
   if (positions.length != 2)
      return false;
   initial = document.getElementById(positions[0]);
   final = document.getElementById(positions[1]);
   if (!initial || !final)
      return false;

   debugx.innerHTML = positions[0] + ',' + positions[1] + '<br>';
   debugx.innerHTML += initial.innerHTML + ' - ' + final.innerHTML;

   final.innerHTML = initial.innerHTML;
   initial.innerHTML = '';

   return false;   
}

// global init of HTTPrequest object
var request;
request = window.XMLHttpRequest ?
new XMLHttpRequest() : new ActiveXObject("MSXML2.XMLHTTP.3.0");

function get_url(url)
{
    request.open("GET", url, false); // synchronous request
    request.send('');
    return request.responseText;
}

// global init of refresh timer
var refresh_seconds = 1;
var refresh_delay = 1;
var end_flag = 0;
var chat_stamp = 0;
var timer = setTimeout("refresh_timer();", refresh_seconds*1000); // milliseconds
var refresh_active = false;
var ply_nr = 0;
var movelist = '';
var wtim = 3600;
var btim = 3600;
var wman = '<img src="gifs/wn.gif">';
var bman = '<img src="gifs/bn.gif">';

function def_king()
{
        document.getElementById('wking').src = "gifs/wk.gif";
        document.getElementById('bking').src = "gifs/bk.gif";
}

function knight_man()
{
    wman = '<img src="gifs/wn.gif">';
    bman = '<img src="gifs/bn.gif">';
    if(document.getElementById('whiteman1') != null)
        document.getElementById('whiteman1').src = "gifs/wn.gif";
    if(document.getElementById('blackman1') != null)
        document.getElementById('blackman1').src = "gifs/bn.gif";
    if(document.getElementById('whiteman2') != null)
        document.getElementById('whiteman2').src = "gifs/wn.gif";
    if(document.getElementById('blackman2') != null)
        document.getElementById('blackman2').src = "gifs/bn.gif";
}

function king_man()
{
    wman = '<img src="gifs/wk.gif">';
    bman = '<img src="gifs/bk.gif">';
    if(document.getElementById('whiteman1') != null)
        document.getElementById('whiteman1').src = "gifs/wk.gif";
    if(document.getElementById('blackman1') != null)
        document.getElementById('blackman1').src = "gifs/bk.gif";
    if(document.getElementById('whiteman2') != null)
        document.getElementById('whiteman2').src = "gifs/wk.gif";
    if(document.getElementById('blackman2') != null)
        document.getElementById('blackman2').src = "gifs/bk.gif";
}

function def_man()
{
    wman = '<img src="gifs/wm.gif">';
    bman = '<img src="gifs/bm.gif">';
    if(document.getElementById('whiteman1') != null)
        document.getElementById('whiteman1').src = "gifs/wm.gif";
    if(document.getElementById('blackman1') != null)
        document.getElementById('blackman1').src = "gifs/bm.gif";
    if(document.getElementById('whiteman2') != null)
        document.getElementById('whiteman2').src = "gifs/wm.gif";
    if(document.getElementById('blackman2') != null)
        document.getElementById('blackman2').src = "gifs/bm.gif";
}

function unicorn_king()
{
        document.getElementById('wking').src = "gifs/wu.gif";
        document.getElementById('bking').src = "gifs/bu.gif";
}

function small_view()
{
    refresh_delay = -1;
    window.open('small.html','mywindow','width=307,height=320');
}

function to_end()
{
    end_flag = 1;
}

function resume_step()
{
    refresh_delay = 1;
}

function step_one()
{
    if(refresh_delay > 10) {
      refresh_delay = 1;
      play_moves();
    }
    refresh_delay = 600;
}

function refresh_timer()
{
    play_moves();
    timer = setTimeout("refresh_timer();", refresh_seconds*1000); // milliseconds
}


function disp_alert()
{
    alert("Yet to be implemented!");
}

function send_line() {
       var url_string;
       if(document.myform.alias.value == '') document.myform.alias.value = 'Anonymous' + (time % 10000);
       url_string = document.myform.alias.value + '] ' + document.myform.line.value;
       url_string = encodeURIComponent(url_string);
       stamp = get_url('chat.cgi?l1=[' + url_string);
       document.myform.line.value = "";
       document.getElementById('chatbox').innerHTML = stamp; // and display
}

function play_moves()
{
    if (refresh_active) // no reentry
       return;

   refresh_active = true;

   // decrement clocks
   if(ply_nr & 1) {
       btim--; if(btim<0) btim=1;
       tmpt = btim % 60; if(tmpt < 10) tmpt = '0'+tmpt;
       document.getElementById('blacktime').innerHTML = Math.floor(btim/60) + ':' + tmpt;

   } else {
       wtim--; if(wtim<0) wtim=1;
       tmpt = wtim % 60; if(tmpt < 10) tmpt = '0'+tmpt;
       document.getElementById('whitetime').innerHTML = Math.floor(wtim/60) + ':' + tmpt;
   }

   // check if it is time to update move list
   refresh_delay--; if(refresh_delay != 0) { refresh_active = 0; return; }

   // check if we already have downloaded moves that are not played yet
   gamemoves = movelist.split(';');


   if( gamemoves.length-2 <= ply_nr || gamemoves[0] == '' ) {
       // All moves we have are played. Fetch new move list
       date = new Date();
       time = date.getTime(); // milliseconds since 1970

       document.getElementById('statusmsg').innerHTML = 'Checking chat.';
       stamp = get_url('chat.cgi?p1='+time);
       if(stamp != chat_stamp) { // chat has been active
         chat_stamp = stamp;
         stamp = get_url('chat.cgi?t1='+time); // fetch new text
         document.getElementById('chatbox').innerHTML = stamp; // and display
       }
       document.getElementById('statusmsg').innerHTML = 'Fetching move list.';
       movelist = get_url('moves.txt?dummy='+time);
       document.getElementById('statusmsg').innerHTML = 'Processing data.';

     // refresh engine PVs (if displayed)
     if(document.getElementById('whitePV') != null) {
       PV  = get_url('moves.txw?dummy='+time);
       document.getElementById('whitePV').innerHTML = 'PV white: ' + PV;
     }
     if(document.getElementById('blackPV') != null) {
       PV2  = get_url('moves.txb?dummy='+time);
       document.getElementById('blackPV').innerHTML = 'PV black: ' + PV2;
     }

       if( gamemoves.length-2 < ply_nr ) {
           ply_nr = 0; historylist = '';
       }
       gamemoves = movelist.split(';');
   }

   document.getElementById('whitename').innerHTML = gamemoves[0];
   document.getElementById('blackname').innerHTML = gamemoves[1];

   historylist = document.getElementById('movehistory').innerHTML;

  do{
   refresh_delay = 10;

   if( gamemoves.length-2 < ply_nr) {
           document.getElementById('movehistory').innerHTML =
               historylist + '<br>Game ended in unknown way<br>Refresh to view next game';
           document.getElementById('movehistory').scrollTop = 10000;
           refresh_delay = -1;
           end_flag = 0;
           refresh_active = 0;
           return;
   }
   if( gamemoves.length-2 > ply_nr) {
       // We have moves to play, from old or new list.
       nextmove = gamemoves[ply_nr+2]; ++ply_nr; // Get next move
       if(nextmove.length == 1) { // game-end message
           if(nextmove == '+') {
               document.getElementById('bking').src = "gifs/bkl.gif";
           }
           if(nextmove == '-') {
               document.getElementById('wking').src = "gifs/wkl.gif";
           }
           if(nextmove == '=') {
               document.getElementById('wking').src = "gifs/wkd.gif";
               document.getElementById('bking').src = "gifs/bkd.gif";
           }
           document.getElementById('movehistory').innerHTML =
               historylist + '<br>' + gamemoves[ply_nr+2] + '<br>Refresh to view next game';
           document.getElementById('movehistory').scrollTop = 10000;
           refresh_delay = -1;
           end_flag = 0;
           refresh_active = 0;
           return;
       }
       nextsquares = nextmove.split('/');
       squares = nextsquares[0].split(':');         // Split in from and to square
       for(i = 0; i < squares.length; i = i + 2) // allow for multiple from, to
       {  if(squares[i].length == 1) {
              if(ply_nr & 1) { // promotion piece
                  if(squares[i] == 'q') tmp = '<img src="gifs/wq.gif">';
                  if(squares[i] == 'n') tmp = '<img src="gifs/wn.gif">';
                  if(squares[i] == 'r') tmp = '<img src="gifs/wr.gif">';
                  if(squares[i] == 'b') tmp = '<img src="gifs/wb.gif">';
                  if(squares[i] == 'm') tmp = wman;
              } else {
                  if(squares[i] == 'q') tmp = '<img src="gifs/bq.gif">';
                  if(squares[i] == 'n') tmp = '<img src="gifs/bn.gif">';
                  if(squares[i] == 'r') tmp = '<img src="gifs/br.gif">';
                  if(squares[i] == 'b') tmp = '<img src="gifs/bb.gif">';
                  if(squares[i] == 'm') tmp = bman;
              }
              document.getElementById(squares[i+1]).innerHTML = tmp;
          } else {
              document.getElementById(squares[i+1]).innerHTML =
              document.getElementById(squares[i]).innerHTML;
              document.getElementById(squares[i]).innerHTML =
              '<img src="gifs/nl.gif">';
          }
       }
       if( ply_nr & 1 )
            historylist = historylist + '<br>' + ((ply_nr+1)/2) + '. ';
       else historylist = historylist + '<br>...    ';
       if(nextsquares.length == 5) {
          historylist = historylist + nextsquares[4];
          if(nextsquares[4] != 'O-O' && nextsquares[4] != 'O-O-O')
              historylist = historylist + squares[1];
       } else historylist = historylist + squares[0] + squares[1];
       if(ply_nr==1) historylist = '1. '+ squares[i-2] + squares[i-1];
       if(nextsquares.length > 1) {
           historylist = historylist + ' {' + nextsquares[1] + '/' + (nextsquares[2]/100) + '}';
           if(ply_nr & 1)
              document.getElementById('whitescore').innerHTML = (nextsquares[2]/100);
           else
              document.getElementById('blackscore').innerHTML = (nextsquares[2]/100);
       }
       if(nextsquares.length >= 4) {
           if(ply_nr & 1) {
               wtim = nextsquares[3];
               tmpt = wtim % 60; if(tmpt < 10) tmpt = '0'+tmpt;
               document.getElementById('whitetime').innerHTML =
                 Math.floor(wtim/60) + ':' + tmpt;
           } else {
               btim = nextsquares[3];
               tmpt = btim % 60; if(tmpt < 10) tmpt = '0'+tmpt;
               document.getElementById('blacktime').innerHTML =
                 Math.floor(btim/60) + ':' + tmpt;
           }
       }
       refresh_delay = 1; // Play fast as long as there are moves
   } else end_flag = 0;
  } while(end_flag);
   document.getElementById('movehistory').innerHTML = historylist;
   document.getElementById('movehistory').scrollTop = 10000;
   refresh_active = false;
}
